
public class Minimizer {

	/*
	 * set_best():
	 *
	 *  Set the global `best' value.
	 *
	 */
	/*static*/ void set_best(int best, int[] path) {
	if (best >= MinTourLen) {
	    if (TspSolver.debug) 
		System.out.println("set_best: " + best + " <-> " + MinTourLen);
	    return;
	}
	synchronized(MinLock) {
	    if (best < MinTourLen) {
		if (TspSolver.debug) {
		    System.out.print("(" + Thread.currentThread().getName() + ") ");
		    System.out.println("set_best MinTourLen: " + best + " (old: " + MinTourLen + ")");
		}
		MinTourLen = best;
		for (int i = 0; i < Tsp.TspSize; i++)
		    MinTour[i] = path[i];
		if (TspSolver.debug) 
		    TspSolver.MakeTourString(Tsp.TspSize, MinTour);
	    }
	}
	}

	/*static*/ int MinTourLen;
	/*static*/ int[] MinTour = new int[Tsp.MAX_TOUR_SIZE];
	/*static*/ Integer MinLock = new Integer(0);

}
